function DisplayOverviewHud:animalsModul(animalType)	
	local txtHeight = 0;
	for key,animal in pairs(DisplayOverviewHud.animals) do
		if key ~= nil and animal ~= nil and animal.object ~= nil then 
			local animalsModule = animal.object:getModuleByName("animals");			
			if animalsModule ~= nil and string.find(tostring(animalType:lower()), tostring(animalsModule:getAnimalType():lower())) and (animal.object.ownerFarmId == 0 or animal.object.ownerFarmId == g_currentMission.player.farmId) and Utils.getNoNil(animalsModule:getNumOfAnimals(), 0) > 0 then
				local animalName = tostring(animalsModule:getAnimalType():lower());				
				drawAnimalType[#drawAnimalType+1] = {};				
				drawAnimalType[#drawAnimalType].animalName = animalName;
				local animalNumber = 0;
				for a=1, #drawAnimalType do
					if string.find(drawAnimalType[a].animalName, animalName) then animalNumber = animalNumber+1;end;
				end;
				if string.find(animal.object.i3dFilename:lower(), "small") then animalNumber = "S ".. animalNumber;else animalNumber = "B ".. animalNumber;end;
				drawAnimalType[#drawAnimalType].output = {};
				drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {Utils.getNoNil(g_i18n:getText("animalPen_".. tostring((animalName))), tostring(animalType:upper())), animalNumber, 0, 0, {}};
				drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("animal_stock"), Utils.getNoNil(animalsModule:getNumOfAnimals(), 0), 0, 0, {}};
				if string.find(animalName, "chicken") and animal.object.numObjectsInPalletSpawnerTrigger ~= nil then --ls17 check later optional
					drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_eggsAvailable"), Utils.getNoNil(animal.object.numObjectsInPalletSpawnerTrigger, 0), 0, 0, {}};
				end;
				--drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_reproductionRate"), 0, 0, 0, {}}; --check later optional				
				if not string.find(animalName, "horse") then
					local prozentColor, isOkay = DisplayOverviewHud:get_hl("getProzentColor", {Utils.getNoNil(animal.object.globalProductionFactor, 0)*100, true}, "getProzentColor Productivity ".. tostring(animalType:upper()));
					if not isOkay then prozentColor = 0;end;
					drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_productivity"), Utils.getNoNil(animal.object.globalProductionFactor, 0)*100, 0, prozentColor, {}};
					local foodSpillageModule = animal.object:getModuleByName("foodSpillage");
					if foodSpillageModule ~= nil then
						prozentColor, isOkay = DisplayOverviewHud:get_hl("getProzentColor", {Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100, true}, "getProzentColor Dirt ".. tostring(animalType:upper()));
						if not isOkay then prozentColor = 0;end;
						drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_cleanliness"), Utils.getNoNil(foodSpillageModule:getSpillageFactor(), 0)*100, 0, prozentColor, {}};
					else
						drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_cleanliness"), "-", 0, 2, {}};
					end;
				end;
				local milkModule = animal.object:getModuleByName("milk");
				if milkModule ~= nil then drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_milkStorage"), DisplayOverviewHud:getFillTypeLevels(milkModule:getFilltypeInfos()), 0, 0, {}};end;
				local liquidManureModule = animal.object:getModuleByName("liquidManure");
				if liquidManureModule ~= nil then drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_liquidManureStorage"), DisplayOverviewHud:getFillTypeLevels(liquidManureModule:getFilltypeInfos()), 0, 0, {}};end;
				local manureModule = animal.object:getModuleByName("manure");
				if manureModule ~= nil then drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("statistic_manureStorage"), DisplayOverviewHud:getFillTypeLevels(manureModule:getFilltypeInfos()), 0, 0, {}};end;
				local palletsModule = animal.object:getModuleByName("pallets");
				if palletsModule ~= nil then drawAnimalType[#drawAnimalType].output[#drawAnimalType[#drawAnimalType].output+1] = {g_i18n:getText("category_pallets"), DisplayOverviewHud:getFillTypeLevels(palletsModule:getFilltypeInfos()), 0, 0, {}};end;
								
				drawAnimalType[#drawAnimalType].input = {};
				local waterModule = animal.object:getModuleByName("water");if waterModule ~= nil then drawAnimalType[#drawAnimalType].input[#drawAnimalType[#drawAnimalType].input+1] = {g_i18n:getText("statistic_water"), DisplayOverviewHud:getFillTypeLevels(waterModule:getFilltypeInfos()), 0, 0, {}};end;
				local strawModule = animal.object:getModuleByName("straw");
				if strawModule ~= nil then drawAnimalType[#drawAnimalType].input[#drawAnimalType[#drawAnimalType].input+1] = {g_i18n:getText("statistic_strawStorage"), DisplayOverviewHud:getFillTypeLevels(strawModule:getFilltypeInfos()), 0, 0, {}};end;
				local foodModule = animal.object:getModuleByName("food");
				local isCapacity = false;
				if foodModule ~= nil then					
					local foodModuleTotal = foodModule:getFilltypeInfos();					
					if foodModuleTotal ~= nil and type(foodModuleTotal) == "table" and #foodModuleTotal > 0 then
						for key1, foodGroupTable in pairs(foodModuleTotal) do							
							if foodGroupTable ~= nil then
								if not isCapacity then 
									table.insert(drawAnimalType[#drawAnimalType].output, 2, {g_i18n:getText("shop_capacity"), Utils.getNoNil(g_i18n:formatNumber(foodGroupTable.capacity), 0), 0, 0, {}});
									isCapacity = true;
								end;
								local fillLevelTotal = g_i18n:formatNumber(foodGroupTable.fillLevel);
								local fillTypesTotal = {};								
								if foodGroupTable.foodGroup ~= nil and foodGroupTable.foodGroup.fillTypes ~= nil then
									local foodGroupName = Utils.getNoNil(foodGroupTable.foodGroup.title, "Unknown");
									for _, fillType in pairs(foodGroupTable.foodGroup.fillTypes) do
										table.insert(fillTypesTotal, fillType);
									end;
									if #fillTypesTotal == 1 then 
										local fillTypeName = FillTypeManager.getFillTypeNameByIndex(g_fillTypeManager, fillTypesTotal[1]);
										foodGroupName = g_fillTypeManager.nameToFillType[fillTypeName].title;
									end;
									drawAnimalType[#drawAnimalType].input[#drawAnimalType[#drawAnimalType].input+1] = {tostring(foodGroupName), fillLevelTotal, 0, 0, fillTypesTotal};
								end;
							end;
						end;						
					end;					
				end;
				txtHeight = math.max(txtHeight, DisplayOverviewHud:setAnimalsTxtWidthHeightTotal(#drawAnimalType, animalType));
			end;
		end;
	end;
	return txtHeight;
end;

function DisplayOverviewHud:getFillTypeLevels(fillTypeModule)
	local fillLevelsTotal = 0;
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then
		for _, fillLevels in pairs(fillTypeModule) do
			fillLevelsTotal = fillLevelsTotal+fillLevels.fillLevel;
		end;
	end;
	return g_i18n:formatNumber(fillLevelsTotal);
end;

function DisplayOverviewHud:setAnimalsTxtWidthHeightTotal(animalTablePos, animalType)
	local animalName = tostring(animalType:lower());
	local txtHeight = 0;
	local txtHeightTotal = 0;
	local maxWidthS = 0;
	local maxWidthN = 0;
	if drawAnimalType ~= nil and drawAnimalType[animalTablePos] ~= nil then		
		local size = DisplayOverviewHud.settings.size;		
		local heightDistance = getTextHeight(size, "Ä_")/2;	
		local widthDif = DisplayOverviewHud.settings.draw.widthDif*2;			
		for whatTable, animalTable in pairs(drawAnimalType[animalTablePos]) do
			if whatTable ~= nil and type(animalTable) == "table" then
				local w1 = 0;
				local w2 = 0;
				local h1 = 0;
				local h2 = 0;				
				for i=1, #animalTable do						
					local inoutput = animalTable[i];					
					if inoutput ~= nil and #inoutput > 0 then
						w1 = getTextWidth(size, tostring(inoutput[1]))+widthDif;
						w2 = getTextWidth(size, tostring(inoutput[2]))+widthDif;
						h1 = getTextHeight(size, tostring(inoutput[1]))+heightDistance;
						h2 = getTextHeight(size, tostring(inoutput[2]))+heightDistance;
						if w1 > maxWidthS then maxWidthS = w1;end;
						if w2 > maxWidthN then maxWidthN = w2;end;
						if txtHeight == 0 and h1 > 0 and h2 > 0 then txtHeight = math.max(h1, h2);end;
						txtHeightTotal = txtHeightTotal+math.max(h1, h2);
						table.insert(inoutput, w1);table.insert(inoutput, w2);table.insert(inoutput, math.max(h1, h2));
					end;
				end;
			end;				
		end;	
	end;	
	if DisplayOverviewHud.settings.draw.height.animals[animalName] == nil then DisplayOverviewHud.settings.draw.height.animals[animalName] = {0};end;
	if DisplayOverviewHud.settings.draw.height.animals[animalName][1] < txtHeightTotal then DisplayOverviewHud.settings.draw.height.animals[animalName] = {txtHeightTotal};end;
	if DisplayOverviewHud.settings.draw.width.animals[animalName] == nil then DisplayOverviewHud.settings.draw.width.animals[animalName] = {sT=0,nT=0, multiply=0, isDraw=1, firstPosY=0};end;
	if DisplayOverviewHud.settings.draw.width.animals[animalName].sT < maxWidthS then DisplayOverviewHud.settings.draw.width.animals[animalName].sT = maxWidthS;end;
	if DisplayOverviewHud.settings.draw.width.animals[animalName].nT < maxWidthN then DisplayOverviewHud.settings.draw.width.animals[animalName].nT = maxWidthN;end;
	if not DisplayOverviewHud.settings.draw.animalModusEveryAlone then
		DisplayOverviewHud.settings.draw.width.animals[animalName].multiply = DisplayOverviewHud.settings.draw.width.animals[animalName].multiply+1;
	else
		DisplayOverviewHud.settings.draw.width.animals[animalName].multiply = 1;
	end;
	--for draw bestPrice fillTypes etc. with animals
	if DisplayOverviewHud.settings.draw.width.animalsST < maxWidthS then DisplayOverviewHud.settings.draw.width.animalsST = maxWidthS;end;
	if DisplayOverviewHud.settings.draw.width.animalsNT < maxWidthN*DisplayOverviewHud.settings.draw.width.animals[animalName].multiply then DisplayOverviewHud.settings.draw.width.animalsNT = maxWidthN*DisplayOverviewHud.settings.draw.width.animals[animalName].multiply;end;	
	--for draw bestPrice fillTypes etc. with animals
	return txtHeight;
end;